Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/HpackDecoder.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/HpackDecoder.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/HpackDecoder.java
@@ -16,6 +16,7 @@
  */
 package org.apache.coyote.http2;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 
 import org.apache.tomcat.util.res.StringManager;
@@ -99,10 +100,10 @@ public class HpackDecoder {
             byte b = buffer.get();
             if ((b & 0b10000000) != 0) {
                 //if the first bit is set it is an indexed header field
-                buffer.position(buffer.position() - 1); //unget the byte
+                ((Buffer)buffer).position(buffer.position() - 1); //unget the byte
                 int index = Hpack.decodeInteger(buffer, 7); //prefix is 7
                 if (index == -1) {
-                    buffer.position(originalPos);
+                    ((Buffer)buffer).position(originalPos);
                     return;
                 } else if(index == 0) {
                     throw new HpackException(
@@ -113,12 +114,12 @@ public class HpackDecoder {
                 //Literal Header Field with Incremental Indexing
                 String headerName = readHeaderName(buffer, 6);
                 if (headerName == null) {
-                    buffer.position(originalPos);
+                    ((Buffer)buffer).position(originalPos);
                     return;
                 }
                 String headerValue = readHpackString(buffer);
                 if (headerValue == null) {
-                    buffer.position(originalPos);
+                    ((Buffer)buffer).position(originalPos);
                     return;
                 }
                 emitHeader(headerName, headerValue);
@@ -127,12 +128,12 @@ public class HpackDecoder {
                 //Literal Header Field without Indexing
                 String headerName = readHeaderName(buffer, 4);
                 if (headerName == null) {
-                    buffer.position(originalPos);
+                    ((Buffer)buffer).position(originalPos);
                     return;
                 }
                 String headerValue = readHpackString(buffer);
                 if (headerValue == null) {
-                    buffer.position(originalPos);
+                    ((Buffer)buffer).position(originalPos);
                     return;
                 }
                 emitHeader(headerName, headerValue);
@@ -140,12 +141,12 @@ public class HpackDecoder {
                 //Literal Header Field never indexed
                 String headerName = readHeaderName(buffer, 4);
                 if (headerName == null) {
-                    buffer.position(originalPos);
+                    ((Buffer)buffer).position(originalPos);
                     return;
                 }
                 String headerValue = readHpackString(buffer);
                 if (headerValue == null) {
-                    buffer.position(originalPos);
+                    ((Buffer)buffer).position(originalPos);
                     return;
                 }
                 emitHeader(headerName, headerValue);
@@ -164,10 +165,10 @@ public class HpackDecoder {
         if (headerCount != 0) {
             throw new HpackException(sm.getString("hpackdecoder.tableSizeUpdateNotAtStart"));
         }
-        buffer.position(buffer.position() - 1); //unget the byte
+        ((Buffer)buffer).position(buffer.position() - 1); //unget the byte
         int size = Hpack.decodeInteger(buffer, 5);
         if (size == -1) {
-            buffer.position(originalPos);
+            ((Buffer)buffer).position(originalPos);
             return false;
         }
         if (size > maxMemorySizeHard) {
@@ -197,7 +198,7 @@ public class HpackDecoder {
     }
 
     private String readHeaderName(ByteBuffer buffer, int prefixLength) throws HpackException {
-        buffer.position(buffer.position() - 1); //unget the byte
+        ((Buffer)buffer).position(buffer.position() - 1); //unget the byte
         int index = Hpack.decodeInteger(buffer, prefixLength);
         if (index == -1) {
             return null;
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/HPackHuffman.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/HPackHuffman.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/HPackHuffman.java
@@ -16,6 +16,7 @@
  */
 package org.apache.coyote.http2;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.Arrays;
 import java.util.HashSet;
@@ -483,7 +484,7 @@ public class HPackHuffman {
                 int rem = code.length;
                 while (rem > 0) {
                     if (!buffer.hasRemaining()) {
-                        buffer.position(start);
+                        ((Buffer)buffer).position(start);
                         return false;
                     }
                     int remainingInByte = 8 - bytePos;
@@ -504,7 +505,7 @@ public class HPackHuffman {
             }
             if (bytePos == 8) {
                 if (!buffer.hasRemaining()) {
-                    buffer.position(start);
+                    ((Buffer)buffer).position(start);
                     return false;
                 }
                 buffer.put(currentBufferByte);
@@ -514,14 +515,14 @@ public class HPackHuffman {
             if (buffer.position() - start > toEncode.length()) {
                 //the encoded version is longer than the original
                 //just return false
-                buffer.position(start);
+                ((Buffer)buffer).position(start);
                 return false;
             }
         }
         if (bytePos > 0) {
             //add the EOS bytes if we have not finished on a single byte
             if (!buffer.hasRemaining()) {
-                buffer.position(start);
+                ((Buffer)buffer).position(start);
                 return false;
             }
             buffer.put((byte) (currentBufferByte | ((0xFF) >> bytePos)));
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Hpack.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/Hpack.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Hpack.java
@@ -16,6 +16,7 @@
  */
 package org.apache.coyote.http2;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 
 import org.apache.tomcat.util.res.StringManager;
@@ -165,7 +166,7 @@ final class Hpack {
                 if (source.remaining() == 0) {
                     //we have run out of data
                     //reset
-                    source.position(sp);
+                    ((Buffer)source).position(sp);
                     return -1;
                 }
                 b = source.get();
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2AsyncParser.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/Http2AsyncParser.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2AsyncParser.java
@@ -17,6 +17,7 @@
 package org.apache.coyote.http2;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CompletionHandler;
 import java.util.concurrent.TimeUnit;
@@ -103,7 +104,7 @@ class Http2AsyncParser extends Http2Pars
         public void completed(Long result, Void attachment) {
             if (streamException || error == null) {
                 ByteBuffer payload = buffers[2];
-                payload.flip();
+                ((Buffer)payload).flip();
                 try {
                     if (streamException) {
                         swallow(streamId, payloadSize, false, payload);
@@ -232,7 +233,7 @@ class Http2AsyncParser extends Http2Pars
         public void completed(Long result, Void attachment) {
             if (streamException || error == null) {
                 ByteBuffer payload = buffers[1];
-                payload.flip();
+                ((Buffer)payload).flip();
                 try {
                     boolean continueParsing;
                     do {
@@ -286,7 +287,7 @@ class Http2AsyncParser extends Http2Pars
                             if (payload.remaining() - 9 >= payloadSize) {
                                 continueParsing = true;
                                 // Now go over frame header
-                                payload.position(payload.position() + 9);
+                                ((Buffer)payload).position(payload.position() + 9);
                                 try {
                                     validateFrame(null, frameType, streamId, flags, payloadSize);
                                 } catch (StreamException e) {
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2AsyncUpgradeHandler.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/Http2AsyncUpgradeHandler.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2AsyncUpgradeHandler.java
@@ -17,6 +17,7 @@
 package org.apache.coyote.http2;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CompletionHandler;
 import java.nio.channels.FileChannel;
@@ -216,11 +217,11 @@ public class Http2AsyncUpgradeHandler ex
         if (writeable) {
             ByteUtil.set31Bits(header, 5, stream.getIdAsInt());
             int orgLimit = data.limit();
-            data.limit(data.position() + len);
+            ((Buffer)data).limit(data.position() + len);
             socketWrapper.write(BlockingMode.BLOCK, protocol.getWriteTimeout(),
                     TimeUnit.MILLISECONDS, null, SocketWrapperBase.COMPLETE_WRITE,
                     applicationErrorCompletion, ByteBuffer.wrap(header), data);
-            data.limit(orgLimit);
+            ((Buffer)data).limit(orgLimit);
             handleAsyncException();
         }
     }
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2Parser.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/Http2Parser.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2Parser.java
@@ -17,6 +17,7 @@
 package org.apache.coyote.http2;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 
@@ -192,9 +193,9 @@ class Http2Parser {
                     input.fill(true, dest, dataLength);
                 } else {
                     int oldLimit = buffer.limit();
-                    buffer.limit(buffer.position() + dataLength);
+                    ((Buffer)buffer).limit(buffer.position() + dataLength);
                     dest.put(buffer);
-                    buffer.limit(oldLimit);
+                    ((Buffer)buffer).limit(oldLimit);
                 }
                 // Process padding before sending any notifications in case
                 // padding is invalid.
@@ -475,12 +476,12 @@ class Http2Parser {
                 input.fill(true, headerReadBuffer, toRead);
             } else {
                 int oldLimit = buffer.limit();
-                buffer.limit(buffer.position() + toRead);
+                ((Buffer)buffer).limit(buffer.position() + toRead);
                 headerReadBuffer.put(buffer);
-                buffer.limit(oldLimit);
+                ((Buffer)buffer).limit(oldLimit);
             }
             // switch to read mode
-            headerReadBuffer.flip();
+            ((Buffer)headerReadBuffer).flip();
             try {
                 hpackDecoder.decode(headerReadBuffer);
             } catch (HpackException hpe) {
@@ -550,7 +551,7 @@ class Http2Parser {
             return;
         }
         if (!mustBeZero && byteBuffer != null) {
-            byteBuffer.position(byteBuffer.position() + len);
+            ((Buffer)byteBuffer).position(byteBuffer.position() + len);
         } else {
             int read = 0;
             byte[] buffer = new byte[1024];
@@ -710,7 +711,7 @@ class Http2Parser {
         default boolean fill(boolean block, ByteBuffer data, int len) throws IOException {
             boolean result = fill(block, data.array(), data.arrayOffset() + data.position(), len);
             if (result) {
-                data.position(data.position() + len);
+                ((Buffer)data).position(data.position() + len);
             }
             return result;
         }
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2UpgradeHandler.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/Http2UpgradeHandler.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Http2UpgradeHandler.java
@@ -18,6 +18,7 @@ package org.apache.coyote.http2;
 
 import java.io.EOFException;
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 import java.util.HashSet;
@@ -762,9 +763,9 @@ class Http2UpgradeHandler extends Abstra
                 try {
                     socketWrapper.write(true, header, 0, header.length);
                     int orgLimit = data.limit();
-                    data.limit(data.position() + len);
+                    ((Buffer)data).limit(data.position() + len);
                     socketWrapper.write(true, data);
-                    data.limit(orgLimit);
+                    ((Buffer)data).limit(orgLimit);
                     socketWrapper.flush(true);
                 } catch (IOException ioe) {
                     handleAppInitiatedIOException(ioe);
@@ -1830,7 +1831,7 @@ class Http2UpgradeHandler extends Abstra
             } catch (IOException ioe) {
                 handleAppInitiatedIOException(ioe);
             }
-            payload.clear();
+            ((Buffer)payload).clear();
         }
 
         @Override
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Stream.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http2/Stream.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http2/Stream.java
@@ -17,6 +17,7 @@
 package org.apache.coyote.http2;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 import java.security.AccessController;
@@ -850,9 +851,9 @@ class Stream extends AbstractStream impl
                 int chunkLimit = chunk.limit();
                 while (chunk.remaining() > 0) {
                     int thisTime = Math.min(buffer.remaining(), chunk.remaining());
-                    chunk.limit(chunk.position() + thisTime);
+                    ((Buffer)chunk).limit(chunk.position() + thisTime);
                     buffer.put(chunk);
-                    chunk.limit(chunkLimit);
+                    ((Buffer)chunk).limit(chunkLimit);
                     if (chunk.remaining() > 0 && !buffer.hasRemaining()) {
                         // Only flush if we have more data to write and the buffer
                         // is full
@@ -922,7 +923,7 @@ class Stream extends AbstractStream impl
                 // Buffer is empty. Nothing to do.
                 return false;
             }
-            buffer.flip();
+            ((Buffer)buffer).flip();
             int left = buffer.remaining();
             while (left > 0) {
                 if (streamReservation == 0) {
@@ -953,7 +954,7 @@ class Stream extends AbstractStream impl
                     left -= connectionReservation;
                 }
             }
-            buffer.clear();
+            ((Buffer)buffer).clear();
             return false;
         }
 
@@ -1014,9 +1015,9 @@ class Stream extends AbstractStream impl
             int chunkLimit = src.limit();
             while (src.remaining() > 0) {
                 int thisTime = Math.min(buffer.remaining(), src.remaining());
-                src.limit(src.position() + thisTime);
+                ((Buffer)src).limit(src.position() + thisTime);
                 buffer.put(src);
-                src.limit(chunkLimit);
+                ((Buffer)src).limit(chunkLimit);
                 if (flush(false, blocking)) {
                     return true;
                 }
@@ -1104,14 +1105,14 @@ class Stream extends AbstractStream impl
                 if (inBuffer.position() > 0) {
                     // Data is available in the inBuffer. Copy it to the
                     // outBuffer.
-                    inBuffer.flip();
+                    ((Buffer)inBuffer).flip();
                     written = inBuffer.remaining();
                     if (log.isDebugEnabled()) {
                         log.debug(sm.getString("stream.inputBuffer.copy",
                                 Integer.toString(written)));
                     }
                     inBuffer.get(outBuffer, 0, written);
-                    inBuffer.clear();
+                    ((Buffer)inBuffer).clear();
                 } else if (!canRead) {
                     return -1;
                 } else {
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/B2CConverter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/buf/B2CConverter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/B2CConverter.java
@@ -18,6 +18,7 @@ package org.apache.tomcat.util.buf;
 
 import java.io.IOException;
 import java.io.UnsupportedEncodingException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.Charset;
@@ -107,7 +108,7 @@ public class B2CConverter {
      */
     public void recycle() {
         decoder.reset();
-        leftovers.position(0);
+        ((Buffer)leftovers).position(0);
     }
 
     /**
@@ -126,8 +127,8 @@ public class B2CConverter {
             bb = ByteBuffer.wrap(bc.getBuffer(), bc.getStart(), bc.getLength());
         } else {
             // Initialize the byte buffer
-            bb.limit(bc.getEnd());
-            bb.position(bc.getStart());
+            ((Buffer)bb).limit(bc.getEnd());
+            ((Buffer)bb).position(bc.getStart());
         }
         if ((cb == null) || (cb.array() != cc.getBuffer())) {
             // Create a new char buffer if anything changed
@@ -135,8 +136,8 @@ public class B2CConverter {
                     cc.getBuffer().length - cc.getEnd());
         } else {
             // Initialize the char buffer
-            cb.limit(cc.getBuffer().length);
-            cb.position(cc.getEnd());
+            ((Buffer)cb).limit(cc.getBuffer().length);
+            ((Buffer)cb).position(cc.getEnd());
         }
         CoderResult result = null;
         // Parse leftover if any are present
@@ -145,16 +146,16 @@ public class B2CConverter {
             // Loop until one char is decoded or there is a decoder error
             do {
                 leftovers.put(bc.subtractB());
-                leftovers.flip();
+                ((Buffer)leftovers).flip();
                 result = decoder.decode(leftovers, cb, endOfInput);
-                leftovers.position(leftovers.limit());
-                leftovers.limit(leftovers.array().length);
+                ((Buffer)leftovers).position(leftovers.limit());
+                ((Buffer)leftovers).limit(leftovers.array().length);
             } while (result.isUnderflow() && (cb.position() == pos));
             if (result.isError() || result.isMalformed()) {
                 result.throwException();
             }
-            bb.position(bc.getStart());
-            leftovers.position(0);
+            ((Buffer)bb).position(bc.getStart());
+            ((Buffer)leftovers).position(0);
         }
         // Do the decoding and get the results into the byte chunk and the char
         // chunk
@@ -172,8 +173,8 @@ public class B2CConverter {
             cc.setEnd(cb.position());
             // Put leftovers in the leftovers byte buffer
             if (bc.getLength() > 0) {
-                leftovers.limit(leftovers.array().length);
-                leftovers.position(bc.getLength());
+                ((Buffer)leftovers).limit(leftovers.array().length);
+                ((Buffer)leftovers).position(bc.getLength());
                 bc.subtract(leftovers.array(), 0, bc.getLength());
             }
         }
@@ -196,16 +197,16 @@ public class B2CConverter {
             bb = ByteBuffer.wrap(bc.array(), bc.arrayOffset() + bc.position(), bc.remaining());
         } else {
             // Initialize the byte buffer
-            bb.limit(bc.limit());
-            bb.position(bc.position());
+            ((Buffer)bb).limit(bc.limit());
+            ((Buffer)bb).position(bc.position());
         }
         if ((cb == null) || (cb.array() != cc.array())) {
             // Create a new char buffer if anything changed
             cb = CharBuffer.wrap(cc.array(), cc.limit(), cc.capacity() - cc.limit());
         } else {
             // Initialize the char buffer
-            cb.limit(cc.capacity());
-            cb.position(cc.limit());
+            ((Buffer)cb).limit(cc.capacity());
+            ((Buffer)cb).position(cc.limit());
         }
         CoderResult result = null;
         // Parse leftover if any are present
@@ -221,16 +222,16 @@ public class B2CConverter {
                     chr = bc.get();
                 }
                 leftovers.put(chr);
-                leftovers.flip();
+                ((Buffer)leftovers).flip();
                 result = decoder.decode(leftovers, cb, endOfInput);
-                leftovers.position(leftovers.limit());
-                leftovers.limit(leftovers.array().length);
+                ((Buffer)leftovers).position(leftovers.limit());
+                ((Buffer)leftovers).limit(leftovers.array().length);
             } while (result.isUnderflow() && (cb.position() == pos));
             if (result.isError() || result.isMalformed()) {
                 result.throwException();
             }
-            bb.position(bc.position());
-            leftovers.position(0);
+            ((Buffer)bb).position(bc.position());
+            ((Buffer)leftovers).position(0);
         }
         // Do the decoding and get the results into the byte chunk and the char
         // chunk
@@ -240,16 +241,16 @@ public class B2CConverter {
         } else if (result.isOverflow()) {
             // Propagate current positions to the byte chunk and char chunk, if
             // this continues the char buffer will get resized
-            bc.position(bb.position());
-            cc.limit(cb.position());
+            ((Buffer)bc).position(bb.position());
+            ((Buffer)cc).limit(cb.position());
         } else if (result.isUnderflow()) {
             // Propagate current positions to the byte chunk and char chunk
-            bc.position(bb.position());
-            cc.limit(cb.position());
+            ((Buffer)bc).position(bb.position());
+            ((Buffer)cc).limit(cb.position());
             // Put leftovers in the leftovers byte buffer
             if (bc.remaining() > 0) {
-                leftovers.limit(leftovers.array().length);
-                leftovers.position(bc.remaining());
+                ((Buffer)leftovers).limit(leftovers.array().length);
+                ((Buffer)leftovers).position(bc.remaining());
                 bc.get(leftovers.array(), 0, bc.remaining());
             }
         }
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/ByteBufferHolder.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/buf/ByteBufferHolder.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/ByteBufferHolder.java
@@ -16,6 +16,7 @@
  */
 package org.apache.tomcat.util.buf;
 
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.concurrent.atomic.AtomicBoolean;
 
@@ -46,7 +47,7 @@ public class ByteBufferHolder {
 
     public boolean flip() {
         if (flipped.compareAndSet(false, true)) {
-            buf.flip();
+            ((Buffer)buf).flip();
             return true;
         } else {
             return false;
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/ByteBufferUtils.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/buf/ByteBufferUtils.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/ByteBufferUtils.java
@@ -19,6 +19,7 @@ package org.apache.tomcat.util.buf;
 import java.lang.reflect.Field;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 
 import org.apache.juli.logging.Log;
@@ -108,7 +109,7 @@ public class ByteBufferUtils {
         }
 
         // Copy data
-        in.flip();
+        ((Buffer)in).flip();
         out.put(in);
 
         if (direct) {
Index: apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/ByteChunk.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/tomcat/util/buf/ByteChunk.java
+++ apache-tomcat-9.0.33-src/java/org/apache/tomcat/util/buf/ByteChunk.java
@@ -19,6 +19,7 @@ package org.apache.tomcat.util.buf;
 import java.io.IOException;
 import java.io.ObjectInputStream;
 import java.io.ObjectOutputStream;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.CharBuffer;
 import java.nio.charset.Charset;
@@ -345,7 +346,7 @@ public final class ByteChunk extends Abs
         // and avoid an extra copy
         if (len == limit && end == start && out != null) {
             out.realWriteBytes(from);
-            from.position(from.limit());
+            ((Buffer)from).position(from.limit());
             return;
         }
         // if we have limit and we're below
@@ -375,13 +376,13 @@ public final class ByteChunk extends Abs
         int remain = len - avail;
         avail = limit - end;
         while (remain >= avail) {
-            from.limit(from.position() + avail);
+            ((Buffer)from).limit(from.position() + avail);
             out.realWriteBytes(from);
-            from.position(from.limit());
+            ((Buffer)from).position(from.limit());
             remain = remain - avail;
         }
 
-        from.limit(fromLimit);
+        ((Buffer)from).limit(fromLimit);
         from.get(buff, end, remain);
         end += remain;
     }
@@ -482,8 +483,8 @@ public final class ByteChunk extends Abs
         }
         int n = Math.min(to.remaining(), getLength());
         to.put(buff, start, n);
-        to.limit(to.position());
-        to.position(to.position() - n);
+        ((Buffer)to).limit(to.position());
+        ((Buffer)to).position(to.position() - n);
         start += n;
         return n;
     }
